## proftpd-dfsg 1.3.6b

=== debian/changelog ===
proftpd-dfsg (1.3.6b-3) unstable; urgency=medium

  * Cherry pick "upstream_4385" from upstream:
   - for upstream #4385 (Closes: #949622)

 -- Hilmar Preusse <hille42@web.de>  Wed, 22 Jan 2020 23:12:44 +0100

proftpd-dfsg (1.3.6b-2) unstable; urgency=medium

  * Cherry pick patch from upstream:
    - for upstream 861 (CVE-2019-19269) (Closes: #946345)
    - for upstream 859 (CVE-2019-19270) (Closes: #946346)
    upstream_pull_859_861_CVE-2019-19270_CVE-2019-19269

 -- Hilmar Preusse <hille42@web.de>  Sun, 08 Dec 2019 14:03:43 +0100

proftpd-dfsg (1.3.6b-1) unstable; urgency=medium

  * New upstream release:
    - Obsoletes patch issue_846_CVE-2019-18217.diff.
    - Backported fix for building mod_sql_mysql using MySQL 8 (Issue #824).

 -- Hilmar Preusse <hille42@web.de>  Mon, 04 Nov 2019 22:08:07 +0100

proftpd-dfsg (1.3.6a-2) unstable; urgency=high

  * Add patch for upstream bug #846 (CVE-2019-18217).
    (Closes: #942831)

 -- Hilmar Preusse <hille42@web.de>  Tue, 22 Oct 2019 13:30:36 +0200

proftpd-dfsg (1.3.6a-1) unstable; urgency=medium

  * New upstream patch release. Obsoletes patches included in upstream:
    - upstream_4372_CVE-2019-12815.diff
    - upstream_4312, upstream_4312_fix_version
    - upstream_4356
    - upstream_4335
    - upstream_4336 (although not mentioned in upstream changelog)
    - github_pr_710 (although not mentioned in upstream changelog)
    - github_pr_594 (although not mentioned in upstream changelog)
    - upstream_pull_567 = Bug#4314
  * Lintian Override: proftpd-dev: pkg-config-multi-arch-wrong-dir
    (file is generated during build).

 -- Hilmar Preusse <hille42@web.de>  Mon, 14 Oct 2019 10:36:04 +0200

proftpd-dfsg (1.3.6-6) unstable; urgency=medium

  * Document that proftpd read all files from /etc/proftpd/conf.d/
    (Closes: #814772).
  * Add patch upstream_4372_CVE-2019-12815.diff to solve CVE-2019-12815.
    (Closes: #932453)

 -- Hilmar Preusse <hille42@web.de>  Tue, 23 Jul 2019 21:04:28 +0200

proftpd-dfsg (1.3.6-5) unstable; urgency=medium

  [ Francesco Paolo Lovergine ]
  * Set the SE Linux context after creating a directory.
    (Closes: #923033)
  * Get upstream pull_567 (Bug#4314) (Closes: #927270)
  * Bump Standards-Version to 4.4.0.
    - make sure we don't call "strip" w/o using dh_strip.

 -- Hilmar Preusse <hille42@web.de>  Tue, 16 Jul 2019 23:34:25 +0200

proftpd-dfsg (1.3.6-4) unstable; urgency=medium

  [ Hilmar Preuße ]
  * Mark -doc package as "Multi-Arch: foreign"
  * Proftp now builds w/ Mariadb > 10.3 (Closes: #918394)

 -- Francesco Paolo Lovergine <frankie@debian.org>  Mon, 14 Jan 2019 12:07:16 +0100

proftpd-dfsg (1.3.6-3) unstable; urgency=medium

  [ Hilmar Preuße ]
  * Pick github_pr_710 from upstream:
    [PATCH] Issue #674: Update mod_sftp to handle changed APIs in OpenSSL
    (Closes: #911875).
  * [PATCH] Bug#4356: Fix infinite loop by actually iterating properly
            for the next configuration record.
  * Pick github_pr_594 from upstream:
    [PATCH] Issue #593: If the IgnoreExtendedAttributes FSOption is used,
    then do not include the EXTENDED attribute flag in the SFTP ATTRS
    responses (Closes: #913824).

  * Run configure w/ --disable-xattr only on kfreebsd to fix FTBFS.
    (Closes: #897168)
  * Do create /run/proftpd also in postinst, if not exists yet.
    (Closes: #608881)
  * New Proftp module package: proftpd-mod-snmp.
  * Add "Enhances: proftpd-basic" to all modules built by this package.
  * d/rules: remove clean code, which is covered by upstreams Makefile.
  * Lintian:
    W: maintainer-script-should-not-parse-etc-passwd-or-group
    E: wrong-path-for-interpreter

  [ Francesco Paolo Lovergine ]
  * Policy bumped to 4.2.1. No changes required.

 -- Francesco Paolo Lovergine <frankie@debian.org>  Wed, 21 Nov 2018 14:30:08 +0100

proftpd-dfsg (1.3.6-2) unstable; urgency=medium

  [ Hilmar Preuße ]
  * lintian: file-contains-trailing-whitespace: debian/changelog

  [ Francesco Paolo Lovergine ]
  * Updated Vcs-* fields to reflect moving to salsa from alioth.
  * Updated maintenance team list for migration from alioth. 
  * Policy bumped to 4.1.4, no changes required.

 -- Francesco Paolo Lovergine <frankie@debian.org>  Sun, 29 Apr 2018 11:00:03 +0200

=== debian/control ===
Source: proftpd-dfsg
Section: net
Priority: optional
Maintainer: ProFTPD Maintainance Team <pkg-proftpd-maintainers@alioth-lists.debian.net>
Uploaders: Francesco Paolo Lovergine <frankie@debian.org>,
           Hilmar Preusse <hille42@web.de>
Standards-Version: 4.4.0
Build-Depends: debhelper (>= 9.20160114),
               libacl1-dev,
               libattr1-dev,
               libcap-dev [linux-any],
               libldap2-dev,
               default-libmysqlclient-dev,
               libncurses5-dev,
               libpam-dev,
               libpcre3-dev,
               libpq-dev,
               libsqlite3-dev,
               libssl-dev,
               libwrap0-dev,
               unixodbc-dev,
               zlib1g-dev,
               libgeoip-dev,
               libmemcached-dev (>= 0.41),
               libhiredis-dev
Homepage: http://www.proftpd.org/
Vcs-Browser: https://salsa.debian.org/debian-proftpd-team/proftpd
Vcs-Git: https://salsa.debian.org/debian-proftpd-team/proftpd.git


Package: proftpd-basic
Architecture: any
Depends: adduser,
         debianutils (>= 1.21.0),
         libpam-runtime (>= 0.76-13.1),
         netbase (>= 4.13),
         sed (>= 4.1.5),
         ucf (>= 0.30),
         lsb-base (>= 3.0-6),
         ${misc:Depends},
         ${shlibs:Depends}
Conflicts: ftp-server
Breaks: proftpd (<< 1.3.2)
Replaces: proftpd (<< 1.3.2)
Provides: ftp-server, proftpd, proftpd-abi-1.3.6b
Suggests: openbsd-inetd | inet-superserver,
          openssl,
          proftpd-mod-ldap,
          proftpd-mod-mysql,
          proftpd-mod-odbc,
          proftpd-mod-pgsql,
          proftpd-mod-sqlite,
          proftpd-mod-geoip,
          proftpd-mod-snmp
Recommends: proftpd-doc
Description: Versatile, virtual-hosting FTP daemon - binaries
 ProFTPD is a powerful modular FTP/SFTP/FTPS server. This File Transfer
 Protocol daemon supports also hidden directories, virtual hosts, and
 per-directory ".ftpaccess" files. It uses a single main configuration
 file, with a syntax similar to Apache.
 .
 Because of the advanced design, anonymous-FTP directories can have
 an arbitrary internal structure (bin, lib, etc, and special files are
 not needed). Advanced features such as multiple password files and
 upload/download ratios are also supported.
 .
 This package contains the daemon and all main modules used for
 common configurations. If you need database-centric authentication
 install the suitable proftpd-mod suggested package.

Package: proftpd-dev
Architecture: any
Depends: libacl1-dev,
         libpcre3-dev,
         libssl-dev,
         libtool,
         libtool-bin,
         proftpd-basic (=${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: pkg-config
Description: Versatile, virtual-hosting FTP daemon - development files
 ProFTPD is a powerful modular FTP/SFTP/FTPS server. This File Transfer
 Protocol daemon supports also hidden directories, virtual hosts, and
 per-directory ".ftpaccess" files. It uses a single main configuration
 file, with a syntax similar to Apache.
 .
 Because of the advanced design, anonymous-FTP directories can have
 an arbitrary internal structure (bin, lib, etc, and special files are
 not needed). Advanced features such as multiple password files and
 upload/download ratios are also supported.
 .
 This package contains all files required to develop thirdr-parties
 modules that can be loaded at run-time by means of DSO support.

Package: proftpd-doc
Architecture: all
Multi-Arch: foreign
Suggests: proftpd-basic
Section: doc
Depends: ${misc:Depends}
Description: Versatile, virtual-hosting FTP daemon - documentation
 ProFTPD is a powerful modular FTP/SFTP/FTPS server. This File Transfer
 Protocol daemon supports also hidden directories, virtual hosts, and
 per-directory ".ftpaccess" files. It uses a single main configuration
 file, with a syntax similar to Apache.
 .
 Because of the advanced design, anonymous-FTP directories can have
 an arbitrary internal structure (bin, lib, etc, and special files are
 not needed). Advanced features such as multiple password files and
 upload/download ratios are also supported.
 .
 This package contains the software documentation.
Homepage: http://www.proftpd.org/docs

Package: proftpd-mod-mysql
Architecture: any
Depends: proftpd-basic (=${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Enhances: proftpd-basic
Description: Versatile, virtual-hosting FTP daemon - MySQL module
 ProFTPD is a powerful modular FTP/SFTP/FTPS server. This File Transfer
 Protocol daemon supports also hidden directories, virtual hosts, and
 per-directory ".ftpaccess" files. It uses a single main configuration
 file, with a syntax similar to Apache.
 .
 Because of the advanced design, anonymous-FTP directories can have
 an arbitrary internal structure (bin, lib, etc, and special files are
 not needed). Advanced features such as multiple password files and
 upload/download ratios are also supported.
 .
 This package provides MySQL based authentication.

Package: proftpd-mod-pgsql
Architecture: any
Depends: proftpd-basic (=${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Enhances: proftpd-basic
Description: Versatile, virtual-hosting FTP daemon - PostgreSQL module
 ProFTPD is a powerful modular FTP/SFTP/FTPS server. This File Transfer
 Protocol daemon supports also hidden directories, virtual hosts, and
 per-directory ".ftpaccess" files. It uses a single main configuration
 file, with a syntax similar to Apache.
 .
 Because of the advanced design, anonymous-FTP directories can have
 an arbitrary internal structure (bin, lib, etc, and special files are
 not needed). Advanced features such as multiple password files and
 upload/download ratios are also supported.
 .
 This package provides PostgreSQL based authentication.

Package: proftpd-mod-ldap
Architecture: any
Depends: proftpd-basic (=${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Enhances: proftpd-basic
Description: Versatile, virtual-hosting FTP daemon - LDAP module
 ProFTPD is a powerful modular FTP/SFTP/FTPS server. This File Transfer
 Protocol daemon supports also hidden directories, virtual hosts, and
 per-directory ".ftpaccess" files. It uses a single main configuration
 file, with a syntax similar to Apache.
 .
 Because of the advanced design, anonymous-FTP directories can have
 an arbitrary internal structure (bin, lib, etc, and special files are
 not needed). Advanced features such as multiple password files and
 upload/download ratios are also supported.
 .
 This package provides LDAP based authentication.

Package: proftpd-mod-odbc
Architecture: any
Depends: proftpd-basic (=${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Enhances: proftpd-basic
Description: Versatile, virtual-hosting FTP daemon - ODBC module
 ProFTPD is a powerful modular FTP/SFTP/FTPS server. This File Transfer
 Protocol daemon supports also hidden directories, virtual hosts, and
 per-directory ".ftpaccess" files. It uses a single main configuration
 file, with a syntax similar to Apache.
 .
 Because of the advanced design, anonymous-FTP directories can have
 an arbitrary internal structure (bin, lib, etc, and special files are
 not needed). Advanced features such as multiple password files and
 upload/download ratios are also supported.
 .
 This package provides ODBC based authentication.

Package: proftpd-mod-sqlite
Architecture: any
Depends: proftpd-basic (=${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Enhances: proftpd-basic
Description: Versatile, virtual-hosting FTP daemon - SQLite3 module
 ProFTPD is a powerful modular FTP/SFTP/FTPS server. This File Transfer
 Protocol daemon supports also hidden directories, virtual hosts, and
 per-directory ".ftpaccess" files. It uses a single main configuration
 file, with a syntax similar to Apache.
 .
 Because of the advanced design, anonymous-FTP directories can have
 an arbitrary internal structure (bin, lib, etc, and special files are
 not needed). Advanced features such as multiple password files and
 upload/download ratios are also supported.
 .
 This package provides SQLite based authentication.

Package: proftpd-mod-geoip
Architecture: any
Depends: proftpd-basic (=${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Enhances: proftpd-basic
Description: Versatile, virtual-hosting FTP daemon - GeoIP module
 ProFTPD is a powerful modular FTP/SFTP/FTPS server. This File Transfer
 Protocol daemon supports also hidden directories, virtual hosts, and
 per-directory ".ftpaccess" files. It uses a single main configuration
 file, with a syntax similar to Apache.
 .
 Because of the advanced design, anonymous-FTP directories can have
 an arbitrary internal structure (bin, lib, etc, and special files are
 not needed). Advanced features such as multiple password files and
 upload/download ratios are also supported.
 .
 This package provides GeoIP functionalities.

Package: proftpd-mod-snmp
Architecture: any
Depends: proftpd-basic (=${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Enhances: proftpd-basic
Description: Versatile, virtual-hosting FTP daemon - SNMP module
 ProFTPD is a powerful modular FTP/SFTP/FTPS server. This File Transfer
 Protocol daemon supports also hidden directories, virtual hosts, and
 per-directory ".ftpaccess" files. It uses a single main configuration
 file, with a syntax similar to Apache.
 .
 Because of the advanced design, anonymous-FTP directories can have
 an arbitrary internal structure (bin, lib, etc, and special files are
 not needed). Advanced features such as multiple password files and
 upload/download ratios are also supported.
 .
 The mod_snmp module implements SNMPv1 and SNMPv2, for monitoring of
 proftpd statistics via SNMP.

## proftpd-dfsg 1.3.6c

=== lib/libcap/Makefile ===
## This libcap (for proftpd) is originally from libcap, at:
##   https://github.com/mhiramat/libcap.git.
## This interface is SPECIFIC TO THE LINUX 2.2 KERNEL!!!  IT IS NOT GUARANTEED
## TO WORK ON ANY PRIOR OR LATER VERSION (ie: 2.1.x or 2.3.x).
## If this library stops working, please contact core@proftpd.org.

#
# defines
#
topdir=$(shell pwd)/..
include ../../Make.rules

KERNEL_HEADERS=/usr/include
LIBTITLE=libcap

#
# Library version
#
LIBNAME=$(LIBTITLE).so
STALIBNAME=$(LIBTITLE).a
#

FILES=cap_alloc cap_proc cap_extint cap_flag cap_text cap_file

INCLS=libcap.h cap_names.h $(INCS)
OBJS=$(addsuffix .o, $(FILES))

all: $(STALIBNAME)

_makenames: _makenames.c cap_names.list.h
	$(CC) $(CFLAGS) $< -o $@

cap_names.h: _makenames
	./_makenames > cap_names.h

cap_names.list.h: Makefile $(KERNEL_HEADERS)/linux/capability.h
	@echo "=> making $@ from $(KERNEL_HEADERS)/linux/capability.h"
	perl -e 'while ($$l=<>) { if ($$l =~ /^\#define[ \t](CAP[_A-Z]+)[ \t]+([0-9]+)\s+$$/) { $$tok=$$1; $$val=$$2; $$tok =~ tr/A-Z/a-z/; print "{\"$$tok\",$$val},\n"; } }' $(KERNEL_HEADERS)/linux/capability.h | fgrep -v 0x > $@

$(STALIBNAME): $(OBJS)
	$(AR) rcs $@ $^
	$(RANLIB) $@

%.o: %.c $(INCLS)
	$(CC) $(CFLAGS) $(IPATH) -c $< -o $@

cap_text.o: cap_text.c $(INCLS)
	$(CC) $(CFLAGS) $(IPATH) -c $< -o $@

install: all
	mkdir -p -m 0755 $(FAKEROOT)$(INCDIR)/sys
	install -m 0644 include/sys/capability.h $(FAKEROOT)$(INCDIR)/sys
	-/sbin/ldconfig

clean:
	rm -f $(OBJS) $(LIBNAME)* $(STALIBNAME)
	rm -f cap_names.h cap_names.list.h _makenames

=== debian/changelog ===
proftpd-dfsg (1.3.6c-2) unstable; urgency=medium

  * Add patch from upstream as follow up for CVE-2020-9273
    cd9036f4ef7a05c107f0ffcb19a018b20267c531.patch
    (Closes: #952557).

 -- Hilmar Preusse <hille42@web.de>  Thu, 27 Feb 2020 20:34:56 +0100

proftpd-dfsg (1.3.6c-1) unstable; urgency=medium

  * New upstream version.
    Contains support for OpenSSH-specific private key format
    (Closes: #932373).
  * A few patches are obsolete (included upstream):
    - quotatab_modules (was not installed anyway)
    - upstream_pull_859_861_CVE-2019-19270_CVE-2019-19269
    - upstream_4385
  * Patches refreshed.

 -- Hilmar Preusse <hille42@web.de>  Thu, 20 Feb 2020 13:52:22 +0100

=== debian/control ===
--- 
+++ 
@@ -42,7 +42,7 @@
 Conflicts: ftp-server
 Breaks: proftpd (<< 1.3.2)
 Replaces: proftpd (<< 1.3.2)
-Provides: ftp-server, proftpd, proftpd-abi-1.3.6b
+Provides: ftp-server, proftpd, proftpd-abi-1.3.6c
 Suggests: openbsd-inetd | inet-superserver,
           openssl,
           proftpd-mod-ldap,

=== debian/rules ===
#!/usr/bin/make -f

PACKAGE=proftpd-basic
PACKAGE_DEV=proftpd-dev
NAME=proftpd
VERSION=$(shell grep PROFTPD_VERSION_TEXT $(CURDIR)/include/version.h|cut -d\" -f2)

#
# HAVE_OPENSSL is required by mod_sql.c.
# See #233031 for details.
#
PROFTPD_FLAGS := -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64 -DHAVE_OPENSSL -DUSE_LDAP_TLS
CFLAGS := $(PROFTPD_FLAGS)
CC := gcc

# Some special build options
ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
  DEVELOPT=--enable-devel=yes
endif
ifneq (,$(findstring verbose,$(DEB_BUILD_OPTIONS)))
DH_VERBOSE=1
export DH_VERBOSE
endif
#ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
#  INSTALL_STRIP=-s
#endif

#
# dpkg-arch rules
#
ifeq (,$(DEB_BUILD_GNU_TYPE))
  include debian/scripts/dpkg-arch.mk
endif

# XAttr does not exist on KFreeBSD
# 
XATTR_NOT_EXISTS := kfreebsd-amd64 kfreebsd-i386
ifneq (,$(filter $(DEB_HOST_ARCH), $(XATTR_NOT_EXISTS)))
  BUILDNOTXATTR=--disable-xattr
endif

include /usr/share/dpkg/buildflags.mk

DSOMODS1 = mod_unique_id:mod_site_misc:mod_load:mod_ban:mod_quotatab:mod_sql:mod_sql_mysql:mod_sql_postgres:mod_sql_sqlite:mod_sql_odbc:mod_dynmasq
DSOMODS2 = mod_quotatab_sql:mod_ldap:mod_quotatab_ldap:mod_ratio:mod_tls:mod_rewrite:mod_radius:mod_wrap:mod_wrap2:mod_wrap2_file
DSOMODS3 = mod_wrap2_sql:mod_quotatab_file:mod_quotatab_radius:mod_facl:mod_ctrls_admin:mod_copy:mod_deflate:mod_ifversion
DSOMODS4 = mod_geoip:mod_exec:mod_sftp:mod_sftp_pam:mod_sftp_sql:mod_shaper:mod_sql_passwd:mod_ifsession:mod_auth_otp:mod_tls_redis
DSOMODS5 = mod_wrap2_redis:mod_redis:mod_memcache:mod_tls_memcache:mod_readme:mod_snmp
CONF_ARGS := --prefix=/usr \
	     --with-includes=$(shell pg_config --includedir)$(shell mysql_config --include|sed -e 's/-I/:/g'|sed -e 's/ //') \
	     --mandir=/usr/share/man --sysconfdir=/etc/$(NAME) --localstatedir=/run --libexecdir=/usr/lib/$(NAME) \
	     --enable-sendfile --enable-facl --enable-dso --enable-autoshadow --enable-ctrls \
	     --enable-ipv6 --enable-nls --enable-memcache --with-lastlog=/var/log/lastlog --enable-pcre $(DEVELOPT) \
	     --disable-strip --enable-redis $(BUILDNOTXATTR)

ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
  CONF_ARGS += --build $(DEB_HOST_GNU_TYPE)
else
  CONF_ARGS += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
endif

debian/control: debian/control.in
	sed -e 's/@VERSION@/$(VERSION)/' $< >$@

debian/proftpd-substvars: debian/proftpd-substvars.in
	sed -e 's/@VERSION@/$(VERSION)/' $< >$@

build-arch: build
build-indep: build
build: debian/proftpd-substvars configure-stamp build-stamp
build-stamp:
	dh_testdir
	dh_auto_build

	touch $@

install: build
	dh_testdir
	dh_prep
	
	dh_auto_install

configure: configure-stamp
configure-stamp:
	dh_testdir
	
	# Use current autotools helpers
	dh_update_autotools_config
	dh_auto_configure -- $(CONF_ARGS) --with-shared=$(DSOMODS1):$(DSOMODS2):$(DSOMODS3):$(DSOMODS4):$(DSOMODS5)

	touch $@

clean: debian/control debian/proftpd-substvars myclean
myclean:
	dh_testdir
	dh_auto_clean
	dh_clean
	
	# A few surplus files are removed using debian/clean
	rm -f $$(find . -type l) $$(find . -name "*~" -o -name "*.orig")
	rm -rf debian/*.gz core

binary-indep: checkroot build
	dh_installdirs -i
	dh_install -i
	dh_installdocs -i
	dh_installchangelogs -i ChangeLog
	dh_installexamples -i
	dh_lintian -i
	
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_fixperms -i
	dh_builddeb -i

binary-arch: checkroot build install
	dh_installdirs -a
	dh_install -a
	dh_installdocs -a
	dh_installchangelogs -a ChangeLog
	dh_installman -a
	dh_installlogrotate -a
	dh_installpam -a --name=$(NAME)
	dh_lintian -a
	# removes ftpasswd.1 installed by upstream see #699800
	rm -f debian/$(PACKAGE)/usr/share/man/man1/ftpasswd.1*
	# removes proftpd.conf installed by upstream
	rm -f debian/$(PACKAGE)/etc/$(NAME)/$(NAME).conf

	# Not sure how to put this into a .files entry.
	install contrib/xferstats.holger-preiss debian/$(PACKAGE)/usr/sbin/ftpstats
	
	# TODO: cleanup {pre|post}{install|rm} scripts; remove
	# --no-scripts statement.
	dh_installinit -a --name=proftpd --no-scripts
	dh_installdebconf -a
	dh_compress -a
	dh_fixperms -a
	dh_makeshlibs -a
	dh_shlibdeps -a
	dh_installdeb -a
	dh_perl -a
	dh_strip -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_fixperms -a
	dh_builddeb -a

binary:	binary-arch binary-indep

checkroot:
	dh_testdir
	dh_testroot

.PHONY: binary binary-arch binary-indep clean checkroot myclean install configure debian/proftpd-substvars debian/control

.PHONY: build build-arch build-indep

## proftpd-dfsg 1.3.7a

=== debian/changelog ===
proftpd-dfsg (1.3.7a-1) unstable; urgency=medium

  New upstream release 1.3.7a:
  * Patches obsoleted
    - applied upstream: reproducible_build, spelling_errors
    - bundled libcap removed: mod_cap
  * Disable/Remove intermediate patches for security issues.

  Debian adaptions:
  * d/clean reduced, clean handed over to upstream.
  * Enable all modules available (and compilable) in 1.3.7a
    (Closes: #965051).
  * Compile and link with libsodium for better crypto support.

  * Install xferstats.holger-preiss the Debian way; using dh-exec.
  * Raise debhelper compat Level to 10.

 -- Hilmar Preusse <hille42@web.de>  Thu, 23 Jul 2020 07:53:17 +0200

proftpd-dfsg (1.3.6c-3) unstable; urgency=medium

  * Remove last(?) debconf cruft:
    - don't call dh_installdebconf in d/rules
    - don't source /usr/share/debconf/confmodule in postinst
  * Remove surplus BD on libattr1-dev (Closes: #953917).

  [ Debian Janitor <janitor@jelmer.uk> ]
  * Trim trailing whitespace.
  * Use secure copyright file specification URI.
  * debian/copyright: use spaces rather than tabs to start continuation
    lines.
  * Wrap long lines in changelog entries: 1.3.5~rc1-2, 1.3.3a-6, 1.3.3a-
    4, 1.3.3a-2, 1.3.2a-1, 1.3.2-3, 1.3.1-17, 1.3.1-10, 1.3.0-26, 1.2.10-
    23, 1.2.10-9, 1.2.10-3, 1.2.10-2, 1.2.9-12, 1.2.9-8, 1.2.0pre9-1.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Refer to specific version of license.

 -- Hilmar Preusse <hille42@web.de>  Mon, 18 May 2020 22:03:58 +0200

=== debian/control ===
--- 
+++ 
@@ -6,8 +6,8 @@
            Hilmar Preusse <hille42@web.de>
 Standards-Version: 4.4.0
 Build-Depends: debhelper (>= 9.20160114),
+               dh-exec,
                libacl1-dev,
-               libattr1-dev,
                libcap-dev [linux-any],
                libldap2-dev,
                default-libmysqlclient-dev,
@@ -22,7 +22,8 @@
                zlib1g-dev,
                libgeoip-dev,
                libmemcached-dev (>= 0.41),
-               libhiredis-dev
+               libhiredis-dev,
+               libsodium-dev
 Homepage: http://www.proftpd.org/
 Vcs-Browser: https://salsa.debian.org/debian-proftpd-team/proftpd
 Vcs-Git: https://salsa.debian.org/debian-proftpd-team/proftpd.git
@@ -42,7 +43,7 @@
 Conflicts: ftp-server
 Breaks: proftpd (<< 1.3.2)
 Replaces: proftpd (<< 1.3.2)
-Provides: ftp-server, proftpd, proftpd-abi-1.3.6c
+Provides: ftp-server, proftpd, proftpd-abi-1.3.7a
 Suggests: openbsd-inetd | inet-superserver,
           openssl,
           proftpd-mod-ldap,

=== debian/rules ===
--- 
+++ 
@@ -33,7 +33,7 @@
 endif
 
 # XAttr does not exist on KFreeBSD
-# 
+#
 XATTR_NOT_EXISTS := kfreebsd-amd64 kfreebsd-i386
 ifneq (,$(filter $(DEB_HOST_ARCH), $(XATTR_NOT_EXISTS)))
   BUILDNOTXATTR=--disable-xattr
@@ -45,7 +45,8 @@
 DSOMODS2 = mod_quotatab_sql:mod_ldap:mod_quotatab_ldap:mod_ratio:mod_tls:mod_rewrite:mod_radius:mod_wrap:mod_wrap2:mod_wrap2_file
 DSOMODS3 = mod_wrap2_sql:mod_quotatab_file:mod_quotatab_radius:mod_facl:mod_ctrls_admin:mod_copy:mod_deflate:mod_ifversion
 DSOMODS4 = mod_geoip:mod_exec:mod_sftp:mod_sftp_pam:mod_sftp_sql:mod_shaper:mod_sql_passwd:mod_ifsession:mod_auth_otp:mod_tls_redis
-DSOMODS5 = mod_wrap2_redis:mod_redis:mod_memcache:mod_tls_memcache:mod_readme:mod_snmp
+DSOMODS5 = mod_wrap2_redis:mod_redis:mod_memcache:mod_tls_memcache:mod_readme:mod_snmp:mod_digest:mod_ident
+DSOMODS6 = mod_log_forensic:mod_qos:mod_statcache:mod_tls_fscache:mod_tls_shmcache
 CONF_ARGS := --prefix=/usr \
 	     --with-includes=$(shell pg_config --includedir)$(shell mysql_config --include|sed -e 's/-I/:/g'|sed -e 's/ //') \
 	     --mandir=/usr/share/man --sysconfdir=/etc/$(NAME) --localstatedir=/run --libexecdir=/usr/lib/$(NAME) \
@@ -86,7 +87,7 @@
 	
 	# Use current autotools helpers
 	dh_update_autotools_config
-	dh_auto_configure -- $(CONF_ARGS) --with-shared=$(DSOMODS1):$(DSOMODS2):$(DSOMODS3):$(DSOMODS4):$(DSOMODS5)
+	dh_auto_configure -- $(CONF_ARGS) --with-shared=$(DSOMODS1):$(DSOMODS2):$(DSOMODS3):$(DSOMODS4):$(DSOMODS5):$(DSOMODS6)
 
 	touch $@
 
@@ -131,12 +132,13 @@
 	rm -f debian/$(PACKAGE)/etc/$(NAME)/$(NAME).conf
 
 	# Not sure how to put this into a .files entry.
-	install contrib/xferstats.holger-preiss debian/$(PACKAGE)/usr/sbin/ftpstats
+	# Installed using dh-exec.
+	#install contrib/xferstats.holger-preiss debian/$(PACKAGE)/usr/sbin/ftpstats
 	
 	# TODO: cleanup {pre|post}{install|rm} scripts; remove
 	# --no-scripts statement.
 	dh_installinit -a --name=proftpd --no-scripts
-	dh_installdebconf -a
+	# dh_installdebconf -a
 	dh_compress -a
 	dh_fixperms -a
 	dh_makeshlibs -a

## proftpd-dfsg 1.3.7a+dfsg

=== debian/changelog ===
proftpd-dfsg (1.3.7a+dfsg-12+deb11u5) bullseye-security; urgency=high

  * LTS Team upload
  * Add autopkgtest suite.
  * Fix issue #1171 patch
  * Fix CVE-2024-57392:
    A Buffer Overflow vulnerability in Proftpd allowed a remote
    attacker to execute arbitrary code and can cause a
    Denial of Service (DoS) on the FTP service by sending a
    maliciously crafted message to the ProFTPD service port.
  * Bug Fix: Blastradius fix breakage. Fix the computation of
    the RADIUS Message-Authenticator signature to conform
    more properly to RFC 2869

 -- Bastien Roucariès <rouca@debian.org>  Sun, 02 Mar 2025 11:00:29 +0000

proftpd-dfsg (1.3.7a+dfsg-12+deb11u4) bullseye; urgency=medium

   * Add patch for upstream issue #1171 (Closes: #1090813).
     "Downloading a file contains the contents of another file."

 -- Hilmar Preuße <hille42@debian.org>  Sun, 16 Feb 2025 23:41:13 +0100

proftpd-dfsg (1.3.7a+dfsg-12+deb11u3) bullseye-security; urgency=medium

   * LTS Team upload
   * Fix CVE-2023-48795: Add patch for Terrapin attack.
   * Fix CVE-2023-51713: make_ftp_cmd in main.c in ProFTPD has a one-byte
     out-of-bounds read, and daemon crash, because of mishandling of
     quote/backslash semantics.
   * Fix CVE-2024-48651: Supplemental Group Inheritance Grants
     Unintended Access to GID 0
     (Closes: #1082326)

 -- Bastien Roucariès <rouca@debian.org>  Mon, 25 Nov 2024 21:20:02 +0000

proftpd-dfsg (1.3.7a+dfsg-12+deb11u2) bullseye; urgency=medium

  * Add patch for upstream issue #1149 (Closes: #993784).

 -- Hilmar Preusse <hille42@web.de>  Sat, 18 Sep 2021 23:42:19 +0200

proftpd-dfsg (1.3.7a+dfsg-12+deb11u1) bullseye; urgency=medium

  * Add patch for upstream issue #1284 (Closes: #993173).
  * Cherry pick patch for issue #1111 (Closes: #992920).

 -- Hilmar Preusse <hille42@web.de>  Sat, 18 Sep 2021 23:15:03 +0200

proftpd-dfsg (1.3.7a+dfsg-12) unstable; urgency=medium

  * In d/postrm skip ucf purging if ucf is not available and make piuparts happy. 

 -- Francesco Paolo Lovergine <frankie@debian.org>  Fri, 15 Jan 2021 15:09:32 +0100

proftpd-dfsg (1.3.7a+dfsg-11) unstable; urgency=medium

  * Missing removing of ucf hashes on purge added to postrm.
  * Removed obsolete target in d/rules.
  * Removed old debconf stuff still around.

 -- Francesco Paolo Lovergine <frankie@debian.org>  Mon, 11 Jan 2021 13:23:46 +0100

proftpd-dfsg (1.3.7a+dfsg-10) unstable; urgency=medium

  * Fixed missing s/mod_snmp/snmp/ in postinst.
    (closes: #979214)

 -- Francesco Paolo Lovergine <frankie@debian.org>  Mon, 04 Jan 2021 11:35:09 +0100

proftpd-dfsg (1.3.7a+dfsg-9) unstable; urgency=medium

  [ Hilmar Preusse ]
  * Add file exclude for uscan.

  [ Francesco Paolo Lovergine ]
  * Moved to dh-compat 13.
  * Added a not-installed file for stuff not installed in any package.
  * Some contrib/ files are now installed by upstream, so changed a bit
    the d/install file.
  * Now in preinst move past existing logrotate file to the new name.
  * Removed spurious exit in preinst that prevented run of dh section.
  * Renamed mod_snmp.conf => snmp.conf for uniformity in naming.
  * Using deb-systemd-invoke instead of systemctl in postinst and
    added a pre-depends on that basis to pre-dep on a recent version
    of init-system-helpers. Thanks lintian!
  * Introduced ${misc:Depends} among p-basic deps to make lintian happy. 

 -- Francesco Paolo Lovergine <frankie@debian.org>  Mon, 04 Jan 2021 11:23:32 +0100

proftpd-dfsg (1.3.7a+dfsg-8) unstable; urgency=medium

  * More spaces eated in main template by silly automagic replacement fixed.
    This is the last one, promised.

 -- Francesco Paolo Lovergine <frankie@debian.org>  Sat, 02 Jan 2021 16:06:30 +0100

proftpd-dfsg (1.3.7a+dfsg-7) unstable; urgency=medium

  * Sigh, too many spaces eated in main template file among commented lines.

 -- Francesco Paolo Lovergine <frankie@debian.org>  Sat, 02 Jan 2021 11:13:55 +0100

proftpd-dfsg (1.3.7a+dfsg-6) unstable; urgency=medium

  * In order to avoid breakage at install time in non standalone mode,
    enable-n-start via systemd has been moved to postinst.
  * NEWS file rearranged and updated.
  * Minor fixes to README.Debian doc.
  * Revised NEWS file and templates for styling.

 -- Francesco Paolo Lovergine <frankie@debian.org>  Fri, 01 Jan 2021 10:42:05 +0100

proftpd-dfsg (1.3.7a+dfsg-5) unstable; urgency=medium

  * Sigh, removed a spurious line introduced in postinst in the last upload.
    (closes: #977853)
  * Now truly installing socket-related systemd files. Migrated to debhelper
    level 11 to finalize a working combination of dh_installsystemd/dh_installinit.
    That triggered also a few changes to debian/rules, including the dropping 
    dh_auto_configure use.
  * Fixed postinst to add new conf files, if missing. That also caused
    breakage at postinst time :-/

 -- Francesco Paolo Lovergine <frankie@debian.org>  Tue, 22 Dec 2020 12:51:44 +0100

proftpd-dfsg (1.3.7a+dfsg-4) unstable; urgency=medium

  * Added a proftpd-core.docs to include a few secondary, but sometimes useful
    contributed docs from upstream.
  * Now using standard makefile for archs as provided by dpkg-dev.
  * Added a sftp.conf template for optional SFTP support.
  * Missing ucf management of some templates added.
  * Now using debhelper-compat virtual in debian/control.
  * Added support files for running proftpd via systemd socket. The preferred
    way of running proftpd is the standalone mode, but now README.Debian explains
    how inet/xinetd/socket can be used instead.
   (closes: #740177, #657484)
  * Removed trailing spaces at the end of lines in debian/changelog to make
    lintian happy.
  * Fixed oversight old dependency of -mod-mysql on proftpd-basic (thanks lintian).
  * Fixed typo in lintian-overrides (thanks lintian).
  * Moved proftpd-basic to oldlibs, because transitional.
  * Fixed debian/watch file for demangling (thanks lintian).



=== debian/control ===
--- 
+++ 
@@ -3,9 +3,9 @@
 Priority: optional
 Maintainer: ProFTPD Maintainance Team <pkg-proftpd-maintainers@alioth-lists.debian.net>
 Uploaders: Francesco Paolo Lovergine <frankie@debian.org>,
-           Hilmar Preusse <hille42@web.de>
-Standards-Version: 4.4.0
-Build-Depends: debhelper (>= 9.20160114),
+           Hilmar Preuße <hille42@debian.org>
+Standards-Version: 4.5.1
+Build-Depends: debhelper-compat (=13),
                dh-exec,
                libacl1-dev,
                libcap-dev [linux-any],
@@ -23,14 +23,15 @@
                libgeoip-dev,
                libmemcached-dev (>= 0.41),
                libhiredis-dev,
-               libsodium-dev
+               libsodium-dev,
+               libmd-dev
 Homepage: http://www.proftpd.org/
 Vcs-Browser: https://salsa.debian.org/debian-proftpd-team/proftpd
 Vcs-Git: https://salsa.debian.org/debian-proftpd-team/proftpd.git
 
-
-Package: proftpd-basic
-Architecture: any
+Package: proftpd-core
+Architecture: any
+Pre-Depends: ${misc:Pre-Depends}
 Depends: adduser,
          debianutils (>= 1.21.0),
          libpam-runtime (>= 0.76-13.1),
@@ -40,10 +41,10 @@
          lsb-base (>= 3.0-6),
          ${misc:Depends},
          ${shlibs:Depends}
-Conflicts: ftp-server
+Conflicts: ftp-server, proftpd-mod-dnsbl
 Breaks: proftpd (<< 1.3.2)
-Replaces: proftpd (<< 1.3.2)
-Provides: ftp-server, proftpd, proftpd-abi-1.3.7a
+Replaces: proftpd (<< 1.3.2), proftpd-mod-dnsbl
+Provides: ftp-server, proftpd, proftpd-abi-1.3.7a, proftpd-mod-dnsbl
 Suggests: openbsd-inetd | inet-superserver,
           openssl,
           proftpd-mod-ldap,
@@ -52,7 +53,9 @@
           proftpd-mod-pgsql,
           proftpd-mod-sqlite,
           proftpd-mod-geoip,
-          proftpd-mod-snmp
+          proftpd-mod-snmp,
+		  proftpd-mod-crypto, 
+		  proftpd-mod-wrap
 Recommends: proftpd-doc
 Description: Versatile, virtual-hosting FTP daemon - binaries
  ProFTPD is a powerful modular FTP/SFTP/FTPS server. This File Transfer
@@ -76,7 +79,7 @@
          libssl-dev,
          libtool,
          libtool-bin,
-         proftpd-basic (=${binary:Version}),
+         proftpd-core (=${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends}
 Suggests: pkg-config
@@ -91,13 +94,13 @@
  not needed). Advanced features such as multiple password files and
  upload/download ratios are also supported.
  .
- This package contains all files required to develop thirdr-parties
+ This package contains all files required to develop third-parties
  modules that can be loaded at run-time by means of DSO support.
 
 Package: proftpd-doc
 Architecture: all
 Multi-Arch: foreign
-Suggests: proftpd-basic
+Suggests: proftpd-core
 Section: doc
 Depends: ${misc:Depends}
 Description: Versatile, virtual-hosting FTP daemon - documentation
@@ -116,8 +119,8 @@
 
 Package: proftpd-mod-mysql
 Architecture: any
-Depends: proftpd-basic (=${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
-Enhances: proftpd-basic
+Depends: proftpd-core (=${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Enhances: proftpd-core
 Description: Versatile, virtual-hosting FTP daemon - MySQL module
  ProFTPD is a powerful modular FTP/SFTP/FTPS server. This File Transfer
  Protocol daemon supports also hidden directories, virtual hosts, and
@@ -133,8 +136,8 @@
 
 Package: proftpd-mod-pgsql
 Architecture: any
-Depends: proftpd-basic (=${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
-Enhances: proftpd-basic
+Depends: proftpd-core (=${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Enhances: proftpd-core
 Description: Versatile, virtual-hosting FTP daemon - PostgreSQL module
  ProFTPD is a powerful modular FTP/SFTP/FTPS server. This File Transfer
  Protocol daemon supports also hidden directories, virtual hosts, and
@@ -150,8 +153,8 @@
 
 Package: proftpd-mod-ldap
 Architecture: any
-Depends: proftpd-basic (=${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
-Enhances: proftpd-basic
+Depends: proftpd-core (=${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Enhances: proftpd-core
 Description: Versatile, virtual-hosting FTP daemon - LDAP module
  ProFTPD is a powerful modular FTP/SFTP/FTPS server. This File Transfer
  Protocol daemon supports also hidden directories, virtual hosts, and
@@ -167,8 +170,8 @@
 
 Package: proftpd-mod-odbc
 Architecture: any
-Depends: proftpd-basic (=${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
-Enhances: proftpd-basic
+Depends: proftpd-core (=${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Enhances: proftpd-core
 Description: Versatile, virtual-hosting FTP daemon - ODBC module
  ProFTPD is a powerful modular FTP/SFTP/FTPS server. This File Transfer
  Protocol daemon supports also hidden directories, virtual hosts, and
@@ -184,8 +187,8 @@
 
 Package: proftpd-mod-sqlite
 Architecture: any
-Depends: proftpd-basic (=${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
-Enhances: proftpd-basic
+Depends: proftpd-core (=${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Enhances: proftpd-core
 Description: Versatile, virtual-hosting FTP daemon - SQLite3 module
  ProFTPD is a powerful modular FTP/SFTP/FTPS server. This File Transfer
  Protocol daemon supports also hidden directories, virtual hosts, and
@@ -201,8 +204,8 @@
 
 Package: proftpd-mod-geoip
 Architecture: any
-Depends: proftpd-basic (=${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
-Enhances: proftpd-basic
+Depends: proftpd-core (=${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Enhances: proftpd-core
 Description: Versatile, virtual-hosting FTP daemon - GeoIP module
  ProFTPD is a powerful modular FTP/SFTP/FTPS server. This File Transfer
  Protocol daemon supports also hidden directories, virtual hosts, and
@@ -218,8 +221,8 @@
 
 Package: proftpd-mod-snmp
 Architecture: any
-Depends: proftpd-basic (=${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
-Enhances: proftpd-basic
+Depends: proftpd-core (=${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Enhances: proftpd-core
 Description: Versatile, virtual-hosting FTP daemon - SNMP module
  ProFTPD is a powerful modular FTP/SFTP/FTPS server. This File Transfer
  Protocol daemon supports also hidden directories, virtual hosts, and
@@ -233,3 +236,47 @@
  .
  The mod_snmp module implements SNMPv1 and SNMPv2, for monitoring of
  proftpd statistics via SNMP.
+
+Package: proftpd-mod-crypto
+Architecture: any
+Depends: proftpd-core (=${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Enhances: proftpd-core
+Breaks: proftpd-basic (<= 1.3.7a+dfsg-3~), proftpd-core (<= 1.3.7a+dfsg-3~)
+Replaces: proftpd-basic (<= 1.3.7a+dfsg-3~), proftpd-core (<= 1.3.7a+dfsg-3~)  
+Description: Versatile, virtual-hosting FTP daemon - TLS/SSL/SFTP modules
+ ProFTPD is a powerful modular FTP/SFTP/FTPS server. This File Transfer
+ Protocol daemon supports also hidden directories, virtual hosts, and
+ per-directory ".ftpaccess" files. It uses a single main configuration
+ file, with a syntax similar to Apache.
+ .
+ Because of the advanced design, anonymous-FTP directories can have
+ an arbitrary internal structure (bin, lib, etc, and special files are
+ not needed). Advanced features such as multiple password files and
+ upload/download ratios are also supported.
+ .
+ The proftpd-mod-crypto package carries some proftp modules having to do
+ with crypto technologies. These modules are linked with libsodium, which
+ is not needed by the main binary:
+  - mod_sftp.so
+  - mod_sql_passwd.so
+  - mod_tls.so
+
+Package: proftpd-mod-wrap
+Architecture: any
+Depends: proftpd-core (=${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Enhances: proftpd-core
+Breaks: proftpd-basic (<= 1.3.7a-3~)
+Replaces: proftpd-basic (<= 1.3.7a-3~)
+Description: Versatile, virtual-hosting FTP daemon - tcpwrapper module
+ ProFTPD is a powerful modular FTP/SFTP/FTPS server. This File Transfer
+ Protocol daemon supports also hidden directories, virtual hosts, and
+ per-directory ".ftpaccess" files. It uses a single main configuration
+ file, with a syntax similar to Apache.
+ .
+ Because of the advanced design, anonymous-FTP directories can have
+ an arbitrary internal structure (bin, lib, etc, and special files are
+ not needed). Advanced features such as multiple password files and
+ upload/download ratios are also supported.
+ .
+ This module is contained in the contrib/mod_wrap.c file for ProFTPD 1.2+. It
+ enables the daemon to use the common tcpwrappers access control library while

=== debian/rules ===
#!/usr/bin/make -f

PACKAGE=proftpd-core
PACKAGE_DEV=proftpd-dev
NAME=proftpd
VERSION=$(shell grep PROFTPD_VERSION_TEXT $(CURDIR)/include/version.h|cut -d\" -f2)

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

# Some special build options
ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
  DEVELOPT=--enable-devel=yes
endif

ifneq (,$(findstring verbose,$(DEB_BUILD_OPTIONS)))
DH_VERBOSE=1
export DH_VERBOSE
endif

ifeq (,$(filter test,$(LOCAL_BUILD_OPTIONS)))
# Disable automated build tests
override_dh_auto_test:
endif

include /usr/share/dpkg/architecture.mk

# XAttr does not exist on KFreeBSD
#
XATTR_NOT_EXISTS := kfreebsd-amd64 kfreebsd-i386
ifneq (,$(filter $(DEB_HOST_ARCH), $(XATTR_NOT_EXISTS)))
  BUILDNOTXATTR=--disable-xattr
endif

include /usr/share/dpkg/buildflags.mk

DSOMODS1 = mod_unique_id:mod_site_misc:mod_load:mod_ban:mod_quotatab:mod_sql:mod_sql_mysql:mod_sql_postgres:mod_sql_sqlite:mod_sql_odbc:mod_dynmasq
DSOMODS2 = mod_quotatab_sql:mod_ldap:mod_quotatab_ldap:mod_ratio:mod_tls:mod_rewrite:mod_radius:mod_wrap:mod_wrap2:mod_wrap2_file
DSOMODS3 = mod_wrap2_sql:mod_quotatab_file:mod_quotatab_radius:mod_facl:mod_ctrls_admin:mod_copy:mod_deflate:mod_ifversion
DSOMODS4 = mod_geoip:mod_exec:mod_sftp:mod_sftp_pam:mod_sftp_sql:mod_shaper:mod_sql_passwd:mod_ifsession:mod_auth_otp:mod_tls_redis
DSOMODS5 = mod_wrap2_redis:mod_redis:mod_memcache:mod_tls_memcache:mod_readme:mod_snmp:mod_digest:mod_ident
DSOMODS6 = mod_log_forensic:mod_qos:mod_statcache:mod_tls_fscache:mod_tls_shmcache:mod_dnsbl
CONF_ARGS := --prefix=/usr --with-pkgconfig=lib/pkgconfig \
	     --with-includes=$(shell pg_config --includedir)$(shell mysql_config --include|sed -e 's/-I/:/g'|sed -e 's/ //') \
	     --mandir=/usr/share/man --sysconfdir=/etc/$(NAME) --localstatedir=/run --libexecdir=/usr/lib/$(NAME) \
	     --enable-sendfile --enable-facl --enable-dso --enable-autoshadow --enable-ctrls --enable-openssl \
	     --enable-ipv6 --enable-nls --enable-memcache --with-lastlog=/var/log/lastlog --enable-pcre $(DEVELOPT) \
	     --disable-strip --enable-redis $(BUILDNOTXATTR)

ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
  CONF_ARGS += --build $(DEB_HOST_GNU_TYPE)
else
  CONF_ARGS += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
endif

debian/control: debian/control.in
	sed -e 's/@VERSION@/$(VERSION)/' $< >$@

debian/proftpd-substvars: debian/proftpd-substvars.in
	sed -e 's/@VERSION@/$(VERSION)/' $< >$@

%:
	dh $@ --without autoreconf

override_dh_auto_configure:
	dh_update_autotools_config

	# upstream autotools stuff is old enough to miss --runstatedir option and break debhelper(>10)
	# dh_auto_configure -- $(CONF_ARGS) --with-shared=$(DSOMODS1):$(DSOMODS2):$(DSOMODS3):$(DSOMODS4):$(DSOMODS5):$(DSOMODS6)
	./configure --infodir=\${prefix}/share/info --disable-option-checking --disable-silent-rules --libdir=\${prefix}/lib/$(DEB_BUILD_GNU_TYPE) --disable-dependency-tracking \
				$(CONF_ARGS) --with-shared=$(DSOMODS1):$(DSOMODS2):$(DSOMODS3):$(DSOMODS4):$(DSOMODS5):$(DSOMODS6)

override_dh_auto_build: debian/proftpd-substvars
	dh_auto_build

override_dh_auto_install:
	dh_auto_install
	rm -f $(CURDIR)/debian/tmp/usr/sbin/in.proftpd

override_dh_auto_clean:
	dh_auto_clean
	# A few surplus files are removed using debian/clean
	rm -f $$(find . -type l) $$(find . -name "*~" -o -name "*.orig")
	rm -rf debian/*.gz core

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog

override_dh_installpam:
	dh_installpam --name=$(NAME)

override_dh_installinit:
	dh_installinit --name=$(NAME)

override_dh_installsystemd:
	dh_installsystemd -p$(PACKAGE) --name=$(NAME) --no-enable --no-start $(NAME).socket
	dh_installsystemd -p$(PACKAGE) --name=$(NAME)@ --no-enable --no-start $(NAME)@.service
	dh_installsystemd -p$(PACKAGE) --name=$(NAME) --no-enable --no-start $(NAME).service

.PHONY: debian/proftpd-substvars debian/control

## proftpd-dfsg 1.3.7b+dfsg

=== debian/changelog ===
proftpd-dfsg (1.3.7b+dfsg-1) unstable; urgency=medium

  * New upstream release, refresh patches, remove applied patches.
  * d/watch: disregard RC versions, hopefully.
  * d/watch: Add signature check.
  * Add debian/gitlab-ci.yml for CI.

 -- Hilmar Preusse <hille42@web.de>  Thu, 15 Jul 2021 23:33:15 +0200

=== debian/watch ===
version=4
#opts="repack,compression=gz,dversionmangle=auto,passive" ftp://ftp.proftpd.org/distrib/source/proftpd-([\d\.]+[a-z]?\+?[a-z]*)\.tar\.gz
#opts="repack,compression=gz,dversionmangle=auto,filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/proftpd-$1\.tar\.gz/" \
opts=repack,compression=gz,repacksuffix=+dfsg,dversionmangle=s/\+dfsg//,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/,\
pgpsigurlmangle=s@archive/refs/tags@releases/download@;\
s@v([^\/]+)\.tar\.gz@v$1/proftpd-$1\.tar\.gz@;\
s/$/.asc/ \
  https://github.com/proftpd/proftpd/tags .*/v?(\d\S+)\.tar\.gz
